VERSION 5.00
Begin VB.UserControl FileProgress 
   BackColor       =   &H8000000E&
   CanGetFocus     =   0   'False
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4695
   ScaleHeight     =   375
   ScaleWidth      =   4695
   Begin VB.Frame Progress 
      BackColor       =   &H8000000D&
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   375
      Begin VB.Label lblProgress 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "0 %"
         ForeColor       =   &H8000000E&
         Height          =   195
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   120
         Width           =   285
      End
   End
   Begin VB.Label lblProgress 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "0 %"
      ForeColor       =   &H8000000D&
      Height          =   195
      Index           =   1
      Left            =   345
      TabIndex        =   2
      Top             =   0
      Width           =   285
   End
End
Attribute VB_Name = "FileProgress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Event Change()                  ' Change occurs when the text in the progress bar changes
Event Progress()                ' Progress occurs when any visual change happens

Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (Ptr() As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Dim m_Max As Currency
Dim m_Min As Currency
Dim m_Value As Currency

Public Function FileCopy(ByRef SourceFile As String, ByRef DestFile As String) As Boolean
    Dim bytChunk() As Byte, lngRemaining As Long
    Dim intFF1 As Integer, intFF2 As Integer, lngFilesize As Long
    Dim lngA As Long, lngMax As Long
    If LenB(Dir$(SourceFile)) Then
        If LenB(Dir$(DestFile)) Then Kill DestFile
        lngFilesize = FileLen(SourceFile)
        If lngFilesize > 0 Then
            intFF1 = FreeFile: Open SourceFile For Binary Access Read As #intFF1
            intFF2 = FreeFile: Open DestFile For Binary Access Write As #intFF2
                Me.Value = m_Min
                lngRemaining = lngFilesize Mod 65536
                If lngRemaining Then
                    ReDim bytChunk(lngRemaining - 1)
                    Get #intFF1, , bytChunk
                    Put #intFF2, , bytChunk
                End If
                lngRemaining = lngFilesize - lngRemaining
                If lngRemaining Then
                    ReDim bytChunk(65535)
                    Do While lngRemaining > 65536
                        Me.Value = (CDbl(m_Max - m_Min) * CDbl(lngFilesize - lngRemaining) / lngFilesize) + m_Min
                        Get #intFF1, , bytChunk
                        Put #intFF2, , bytChunk
                        lngRemaining = lngRemaining - 65536
                    Loop
                End If
                Me.Value = m_Max
            Close #intFF2
            Close #intFF1
            FileCopy = True
            Exit Function
        End If
    End If
    Me.Value = m_Min
End Function

Public Property Get GetByteArray(ByRef Filename As String) As Byte()
    Dim bytFake() As Byte, bytOut() As Byte, lngFakeHeader(5) As Long
    Dim intFF As Integer, lngFilesize As Long
    Dim lngA As Long, lngMax As Long
    If LenB(Dir$(Filename)) Then
        lngFilesize = FileLen(Filename)
        If lngFilesize > 0 Then
            ReDim bytOut(lngFilesize - 1)
            lngFakeHeader(0) = 1
            lngFakeHeader(1) = 1
            lngFakeHeader(3) = VarPtr(bytOut(0))
            lngFakeHeader(4) = 65536
            CopyMemory ByVal VarPtrArray(bytFake), VarPtr(lngFakeHeader(0)), 4&
            intFF = FreeFile
            Open Filename For Binary Access Read As #intFF
                Me.Value = m_Min
                lngMax = lngFilesize \ 65536
                For lngA = 1 To lngMax
                    Get #intFF, , bytFake
                    lngFakeHeader(3) = VarPtr(bytOut(lngA * 65536))
                    Me.Value = (CDbl(m_Max - m_Min) * CDbl(lngA) / lngMax) + m_Min
                Next lngA
                lngFakeHeader(4) = lngFilesize Mod 65536
                If lngFakeHeader(4) > 0 Then
                     Get #intFF, , bytFake
                End If
                Me.Value = m_Max
            Close #intFF
            CopyMemory ByVal VarPtrArray(bytFake), 0&, 4&
            GetByteArray = bytOut
            Exit Property
        End If
    End If
    Me.Value = m_Min
End Property

Public Property Get GetString(ByRef Filename As String) As String
    GetString = StrConv(Me.GetByteArray(Filename), vbUnicode)
End Property

Public Property Get Max() As Currency
    Max = m_Max
End Property

Public Property Let Max(ByVal NewValue As Currency)
    If NewValue > m_Min Then
        m_Max = NewValue
        Me.Value = m_Value
        PropertyChanged "Max"
    End If
End Property

Public Property Get Min() As Currency
    Min = m_Min
End Property

Public Property Let Min(ByVal NewValue As Currency)
    If NewValue < m_Max Then
        m_Min = NewValue
        Me.Value = m_Value
        PropertyChanged "Min"
    End If
End Property

Public Property Get Value() As Currency
    Value = m_Value
End Property

Public Property Let Value(ByVal NewValue As Currency)
    Dim strPercent As String
    If NewValue >= m_Min Then Else NewValue = m_Min
    If NewValue <= m_Max Then Else NewValue = m_Max
    m_Value = NewValue
    strPercent = Fix(((m_Value - m_Min) / (m_Max - m_Min)) * 100) & " %"
    If strPercent <> lblProgress(0).Caption Then
        lblProgress(0).Caption = strPercent
        lblProgress(1).Caption = strPercent
        RaiseEvent Change
    End If
    UserControl_Resize
End Property

Private Sub UserControl_Initialize()
    Progress.Move -30, 0, 30, ScaleHeight
End Sub

Private Sub UserControl_InitProperties()
    m_Max = 10000
    m_Min = 0
    m_Value = 0
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Max = PropBag.ReadProperty("Max", 10000)
    m_Min = PropBag.ReadProperty("Min", 0)
    m_Value = PropBag.ReadProperty("Value", 0)
End Sub

Private Sub UserControl_Resize()
    Dim sngLeft As Single, sngTop As Single, sngWidth As Single
    sngLeft = (ScaleWidth - lblProgress(1).Width) \ 2
    sngTop = (ScaleHeight - lblProgress(0).Height) \ 2
    If lblProgress(1).Left <> sngLeft Or lblProgress(1).Top <> sngTop Then
        lblProgress(1).Move sngLeft, sngTop
        lblProgress(0).Move lblProgress(1).Left + 30, lblProgress(1).Top
    End If
    If m_Value - m_Min > 0 Then
        sngWidth = ((m_Value - m_Min) / (m_Max - m_Min)) * ScaleWidth + 30
    Else
        sngWidth = 30
    End If
    If Progress.Width <> sngWidth Then Progress.Width = sngWidth: DoEvents: RaiseEvent Progress
    If Progress.Height <> ScaleHeight Then Progress.Height = ScaleHeight
End Sub

Private Sub UserControl_Show()
    UserControl_Resize
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Max", m_Max
    PropBag.WriteProperty "Min", m_Min
    PropBag.WriteProperty "Value", m_Value
End Sub
